Index: /gsdl/trunk/perllib/basebuildproc.pm
===================================================================
--- /gsdl/trunk/perllib/basebuildproc.pm	(revision 18470)
+++ /gsdl/trunk/perllib/basebuildproc.pm	(revision 18471)
@@ -355,5 +355,5 @@
 	my $core_field = $2;
 
-	if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 	    $self->{'doc_mdprefix_fields'}->{$prefix}->{$core_field}++;
 	    $self->{'mdprefix_fields'}->{$prefix}->{$core_field}++;
@@ -369,5 +369,5 @@
 	# implicit 'ex' metadata set
 
-	if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 
 	    $self->{'doc_mdprefix_fields'}->{'ex'}->{$field}++;
@@ -414,5 +414,5 @@
     }
 
-    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 	#add this document to the browse structure
 	push(@{$self->{'doclist'}},$doc_obj->get_OID()) 
@@ -434,5 +434,5 @@
     &classify::classify_doc ($self->{'classifiers'}, $doc_obj, $edit_mode);
 
-    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 	# this is another document
 	$self->{'num_docs'} += 1 unless ($doctype eq "classification");
@@ -463,5 +463,5 @@
 
 	# update a few statistics
-	if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 
 	    $self->{'num_bytes'} += $doc_obj->get_text_length ($section);
@@ -511,5 +511,5 @@
 		# special case for URL metadata
 		if ($field =~ /^URL$/i) {
-		    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+		    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 
 			&dbutil::write_infodb_entry($self->{'infodbtype'}, $infodb_handle, $value, { 'section' => [ $section_OID ] });
@@ -597,5 +597,5 @@
 	} 
 	
-	if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 
 	    &dbutil::write_infodb_entry($self->{'infodbtype'}, $infodb_handle, $section_OID, \%section_infodb);
@@ -610,5 +610,5 @@
 	unless (ref($self) eq "lucenebuildproc")
 	{
-	    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 		
 		if ($self->{'db_level'} eq "document") {
@@ -651,5 +651,5 @@
     my ($doc_obj, $filename) = @_;
 
-    $self->infodbedit($doc_obj,$filename,"reindex");
+    $self->infodbedit($doc_obj,$filename,"update");
 }
 
Index: /gsdl/trunk/perllib/classify/AZList.pm
===================================================================
--- /gsdl/trunk/perllib/classify/AZList.pm	(revision 18470)
+++ /gsdl/trunk/perllib/classify/AZList.pm	(revision 18471)
@@ -124,5 +124,5 @@
     my $outhandle = $self->{'outhandle'};
 
-    if (($edit_mode eq "delete") || ($edit_mode eq "reindex")) {
+    if (($edit_mode eq "delete") || ($edit_mode eq "update")) {
 	$self->oid_hash_delete($doc_OID,'list');
 	return if ($edit_mode eq "delete");	    
Index: /gsdl/trunk/perllib/lucenebuildproc.pm
===================================================================
--- /gsdl/trunk/perllib/lucenebuildproc.pm	(revision 18470)
+++ /gsdl/trunk/perllib/lucenebuildproc.pm	(revision 18471)
@@ -79,5 +79,5 @@
 
     # this is another document
-    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 	$self->{'num_docs'} += 1;
     }
@@ -157,5 +157,5 @@
 	}
 
-	if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 	    $self->{'num_bytes'} += $doc_obj->get_text_length ($section);
 	}
@@ -258,5 +258,5 @@
 		$new_text = $self->filter_text ($field, $new_text);
 
-		if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+		if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 		    $self->{'num_processed_bytes'} += length ($new_text);
 		    $text .= "$new_text";
@@ -318,5 +318,5 @@
 	    $new_text = $self->filter_text ("metadata", $new_text);
 	    
-	    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 		$self->{'num_processed_bytes'} += length ($new_text);
 		$text .= "$new_text";
@@ -337,5 +337,5 @@
 	    $new_text = $self->filter_text ("allfields", $new_text);
 	    
-	    if (($edit_mode eq "add") || ($edit_mode eq "reindex")) {
+	    if (($edit_mode eq "add") || ($edit_mode eq "update")) {
 		$self->{'num_processed_bytes'} += length ($new_text);
 		$text .= "$new_text";
@@ -372,5 +372,5 @@
     my ($doc_obj,$file) = @_;
 
-    $self->textedit($doc_obj,$file,"reindex");
+    $self->textedit($doc_obj,$file,"update");
 }
 