Index: gsdl/trunk/configure
===================================================================
--- gsdl/trunk/configure	(revision 18486)
+++ gsdl/trunk/configure	(revision 18487)
@@ -310,5 +310,5 @@
 
 ac_subdirs_all="$ac_subdirs_all common-src build-src runtime-src"
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ ENABLE_ACCENTFOLD USE_SQLITE LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ ENABLE_ACCENTFOLD USE_SQLITE USE_APACHE_HTTPD LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
 ac_subst_files=''
 
@@ -859,4 +859,5 @@
   --disable-accentfold    Disable Accent Folding for MGPP
   --disable-sqlite        Disable SQLite support
+  --enable-apache-httpd   Enable Apache httpd support
 
 Optional Packages:
@@ -1333,4 +1334,5 @@
 
 
+
 USE_FASTCGI=0
 if test USE_FASTCGI = 1; then
@@ -1428,4 +1430,18 @@
 #define USE_SQLITE $USE_SQLITE
 _ACEOF
+
+
+
+# Check whether --enable-apache-httpd or --disable-apache-httpd was given.
+if test "${enable_apache_httpd+set}" = set; then
+  enableval="$enable_apache_httpd"
+  USE_APACHE_HTTPD=1
+else
+  USE_APACHE_HTTPD=0
+fi;
+cat >>confdefs.h <<\_ACEOF
+#define USE_APACHE_HTTPD $USE_APACHE_HTTPD
+_ACEOF
+
 
 
@@ -7912,4 +7928,5 @@
 s,@ENABLE_ACCENTFOLD@,$ENABLE_ACCENTFOLD,;t t
 s,@USE_SQLITE@,$USE_SQLITE,;t t
+s,@USE_APACHE_HTTPD@,$USE_APACHE_HTTPD,;t t
 s,@LDFLAGS@,$LDFLAGS,;t t
 s,@CFLAGS@,$CFLAGS,;t t
Index: gsdl/trunk/runtime-src/configure
===================================================================
--- gsdl/trunk/runtime-src/configure	(revision 18486)
+++ gsdl/trunk/runtime-src/configure	(revision 18487)
@@ -310,5 +310,5 @@
 
 ac_subdirs_all="$ac_subdirs_all packages"
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ ENABLE_ACCENTFOLD USE_SQLITE LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ ENABLE_ACCENTFOLD USE_SQLITE USE_APACHE_HTTPD LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
 ac_subst_files=''
 
@@ -859,4 +859,5 @@
   --disable-accentfold    Disable Accent Folding for MGPP
   --disable-sqlite        Disable SQLite support
+  --enable-apache-httpd   Enable Apache httpd support
 
 Optional Packages:
@@ -1433,4 +1434,18 @@
 
 
+# Check whether --enable-apache-httpd or --disable-apache-httpd was given.
+if test "${enable_apache_httpd+set}" = set; then
+  enableval="$enable_apache_httpd"
+  USE_APACHE_HTTPD=1
+else
+  USE_APACHE_HTTPD=0
+fi;
+cat >>confdefs.h <<\_ACEOF
+#define USE_APACHE_HTTPD $USE_APACHE_HTTPD
+_ACEOF
+
+
+
+
 LDFLAGS=$LDFLAGS
 
@@ -7895,4 +7910,5 @@
 s,@ENABLE_ACCENTFOLD@,$ENABLE_ACCENTFOLD,;t t
 s,@USE_SQLITE@,$USE_SQLITE,;t t
+s,@USE_APACHE_HTTPD@,$USE_APACHE_HTTPD,;t t
 s,@LDFLAGS@,$LDFLAGS,;t t
 s,@CFLAGS@,$CFLAGS,;t t