Index: /gsdl/trunk/perllib/basebuildproc.pm
===================================================================
--- /gsdl/trunk/perllib/basebuildproc.pm	(revision 18507)
+++ /gsdl/trunk/perllib/basebuildproc.pm	(revision 18508)
@@ -1,3 +1,3 @@
-###########################################################################
+##########################################################################
 #
 # basebuildproc.pm -- 
Index: /gsdl/trunk/perllib/classify/BaseClassifier.pm
===================================================================
--- /gsdl/trunk/perllib/classify/BaseClassifier.pm	(revision 18507)
+++ /gsdl/trunk/perllib/classify/BaseClassifier.pm	(revision 18508)
@@ -308,5 +308,5 @@
     foreach my $existing_oid (@{$self->{$field}}) {
 	if ($existing_oid eq $delete_oid) {
-	    print $outhandle "  Deleting $delete_oid\n";
+	    print $outhandle "  Deleting $delete_oid for ", ref $self, "\n";
 	}
 	else {
@@ -324,5 +324,5 @@
     my $outhandle = $self->{'outhandle'};
 
-    print $outhandle "  Deleting $delete_oid\n";
+    print $outhandle "  Deleting $delete_oid for ", ref $self, "\n";
     delete $self->{$field}->{$delete_oid};
 }
Index: /gsdl/trunk/perllib/classify/GenericList.pm
===================================================================
--- /gsdl/trunk/perllib/classify/GenericList.pm	(revision 18507)
+++ /gsdl/trunk/perllib/classify/GenericList.pm	(revision 18508)
@@ -233,7 +233,10 @@
     return if (!$classify_section);
 
-    if ($edit_mode eq "delete") {
+
+    if (($edit_mode eq "delete") || ($edit_mode eq "update")) {
 	$self->oid_array_delete($section_OID,'OIDs');
-	return;
+	if ($edit_mode eq "delete") {
+	    return;
+	}
     }
    
Index: /gsdl/trunk/perllib/doc.pm
===================================================================
--- /gsdl/trunk/perllib/doc.pm	(revision 18507)
+++ /gsdl/trunk/perllib/doc.pm	(revision 18508)
@@ -67,5 +67,5 @@
     if (defined $source_filename) {
 	$source_filename = &util::filename_within_collection($source_filename);
-	print STDERR "******doc.pm::new(): no file rename method provided\n" unless $rename_method;
+	print STDERR "****** doc.pm::new(): no file rename method provided\n" unless $rename_method;
 	$self->set_source_filename ($source_filename, $rename_method);
     }
Index: /gsdl/trunk/perllib/inexport.pm
===================================================================
--- /gsdl/trunk/perllib/inexport.pm	(revision 18507)
+++ /gsdl/trunk/perllib/inexport.pm	(revision 18508)
@@ -169,16 +169,4 @@
 		    $val =~ s/^<index-status>(.*)$/<index-status>D/m;
 		    &GDBMUtils::gdbmDatabaseSet($arcinfo_doc_filename,$oid,$val);
-		    my $doc_file = $doc_rec->{'doc-file'}->[0];
-
-		    my $doc_filename = &util::filename_cat($archivedir,$doc_file);
-
-
-		    my ($doc_tailname, $doc_dirname, $suffix) 
-			= File::Basename::fileparse($doc_filename, "\\.[^\\.]+\$");
-
-		    print STDERR "Removing $doc_dirname\n" if ($verbosity>2);
-
-		    &util::rm_r($doc_dirname);
-		    
 		}
 	    }
@@ -258,3 +246,4 @@
 
 
+
 1;
Index: /gsdl/trunk/perllib/plugins/ArchivesInfPlugin.pm
===================================================================
--- /gsdl/trunk/perllib/plugins/ArchivesInfPlugin.pm	(revision 18507)
+++ /gsdl/trunk/perllib/plugins/ArchivesInfPlugin.pm	(revision 18508)
@@ -88,4 +88,6 @@
 
     my $archive_info = $self->{'archive_info'};
+    my $verbosity = $self->{'verbosity'};
+    my $outhandle = $self->{'outhandle'};
 
     if (defined $archive_info) {
@@ -98,5 +100,4 @@
 
 	    my $index_status = $archive_info->get_status_info($doc_oid);
-####	    print STDERR "*** Away to Update $doc_oid $index_status\n";
 
 	    if ($index_status eq "D") {
@@ -104,4 +105,18 @@
 		$archive_info->delete_info($doc_oid);
 		&GDBMUtils::gdbmDatabaseRemove($archive_info_filename,$doc_oid);
+
+		my $doc_file = $subfile->[0];
+		my $base_dir =$self->{'base_dir'};
+
+		my $doc_filename = &util::filename_cat($base_dir,$doc_file);
+
+		my ($doc_tailname, $doc_dirname, $suffix) 
+		    = File::Basename::fileparse($doc_filename, "\\.[^\\.]+\$");
+
+		print STDERR "Removing $doc_dirname\n" if ($verbosity>2);
+
+		&util::rm_r($doc_dirname);
+
+
 	    }
 	    elsif ($index_status =~ m/^(I|R)$/) {
@@ -120,4 +135,5 @@
     my ($pluginfo, $base_dir, $processor, $maxdocs) = @_;
 
+    $self->{'base_dir'} = $base_dir;
 }
 
@@ -257,6 +273,4 @@
 	    }
 
-
-
 	    if ($process_file) {
 		# note: metadata is not carried on to the next level