Index: gsdl/trunk/etc/marc2dc.txt
===================================================================
--- gsdl/trunk/etc/marc2dc.txt	(revision 18537)
+++ gsdl/trunk/etc/marc2dc.txt	(revision 18537)
@@ -0,0 +1,86 @@
+#
+# This file is used by MARCPlug for mapping MARC field numbers to
+# Greenstone-style metadata.
+#
+# The field numbers listed in this file are for USMARC / MARC21.
+#
+# Lines beginning with "#" are comments.
+# The format for these files are:
+#  <number> -> GreenstoneMetadataName
+#
+# This is loosely based on the MARC -> Dublin Core mapping as found at
+#   http://lcweb.loc.gov/marc/dccross.html
+#
+# The problem with that is that some mappings are conditional on
+# subfield values...
+
+### Contributor	###
+# 720 = "Uncontrolled Name", with $e=collaborator
+
+### Coverage	###
+#500 -> Coverage
+
+### Creator	###
+# 720 = "Uncontrolled Name" with $e=author
+720 -> Creator
+# 100 = "Personal Name"
+100	-> Creator
+# 110 = "Corporate Name" 
+110	-> Creator
+# 111 = "Meeting Name"
+111	-> Creator
+
+### Date	###
+# Don't do this yet, as greenstone expects dates in YYYYMMDD format...
+# 260, $c (but also see Publisher below)
+# 260 -> Date
+
+### Description	###
+# 520 = "Summary, Note"
+520 -> Description
+
+### Identifier	###
+# 024 = "Standard Identifier/number"
+# greenstone uses its own Identifier metadata
+024 -> MarcIdentifier
+
+# 856 = "Electronic Location"
+856 -> URL
+
+### Language	###
+# Greenstone has its own Language metadata...
+546 -> MarcLanguage
+
+### Publisher	###
+# 260 = "Publication, etc"
+# 260 $b if $e=publisher... (but see Date)
+260 -> Publisher
+
+### Relation	###
+# 787 = "Nonspecific Relationship Note"
+787 -> Relation
+
+### Rights	###
+# 540 = "Reproduction Note"
+540 -> Rights
+
+### Source	###
+# greenstone has its own Source metadata...
+# 786 = "Data Source Entry"
+786 -> MarcSource
+
+### Subject	###
+# 650 = "Subject: Topical Term"
+650 -> Subject
+# 653 = "Index Term: Uncontrolled"
+653 -> Subject
+
+### Title	###
+# 245 = "Title Statement"
+245	-> Title
+# 246 = "Varying Form of Title"
+
+### Type	###
+# 655 = "Index Term - Genre/Form"
+655 -> Type
+
Index: gsdl/trunk/etc/marctodc.txt
===================================================================
--- gsdl/trunk/etc/marctodc.txt	(revision 18536)
+++ 	(revision )
@@ -1,86 +1,0 @@
-#
-# This file is used by MARCPlug for mapping MARC field numbers to
-# Greenstone-style metadata.
-#
-# The field numbers listed in this file are for USMARC / MARC21.
-#
-# Lines beginning with "#" are comments.
-# The format for these files are:
-#  <number> -> GreenstoneMetadataName
-#
-# This is loosely based on the MARC -> Dublin Core mapping as found at
-#   http://lcweb.loc.gov/marc/dccross.html
-#
-# The problem with that is that some mappings are conditional on
-# subfield values...
-
-### Contributor	###
-# 720 = "Uncontrolled Name", with $e=collaborator
-
-### Coverage	###
-#500 -> Coverage
-
-### Creator	###
-# 720 = "Uncontrolled Name" with $e=author
-720 -> Creator
-# 100 = "Personal Name"
-100	-> Creator
-# 110 = "Corporate Name" 
-110	-> Creator
-# 111 = "Meeting Name"
-111	-> Creator
-
-### Date	###
-# Don't do this yet, as greenstone expects dates in YYYYMMDD format...
-# 260, $c (but also see Publisher below)
-# 260 -> Date
-
-### Description	###
-# 520 = "Summary, Note"
-520 -> Description
-
-### Identifier	###
-# 024 = "Standard Identifier/number"
-# greenstone uses its own Identifier metadata
-024 -> MarcIdentifier
-
-# 856 = "Electronic Location"
-856 -> URL
-
-### Language	###
-# Greenstone has its own Language metadata...
-546 -> MarcLanguage
-
-### Publisher	###
-# 260 = "Publication, etc"
-# 260 $b if $e=publisher... (but see Date)
-260 -> Publisher
-
-### Relation	###
-# 787 = "Nonspecific Relationship Note"
-787 -> Relation
-
-### Rights	###
-# 540 = "Reproduction Note"
-540 -> Rights
-
-### Source	###
-# greenstone has its own Source metadata...
-# 786 = "Data Source Entry"
-786 -> MarcSource
-
-### Subject	###
-# 650 = "Subject: Topical Term"
-650 -> Subject
-# 653 = "Index Term: Uncontrolled"
-653 -> Subject
-
-### Title	###
-# 245 = "Title Statement"
-245	-> Title
-# 246 = "Varying Form of Title"
-
-### Type	###
-# 655 = "Index Term - Genre/Form"
-655 -> Type
-