Index: gsdl/trunk/etc/marc2qdc.txt
===================================================================
--- gsdl/trunk/etc/marc2qdc.txt	(revision 18538)
+++ gsdl/trunk/etc/marc2qdc.txt	(revision 18539)
@@ -4,87 +4,87 @@
 #   http://www.loc.gov/marc/marc2dc.html
 
-245			  -> Title				
-130, 210, 240, 242, 246	  -> Title^Alternative	
-730, 740		  -> Title^Alternative	
+245			  -> dc.Title				
+130, 210, 240, 242, 246	  -> dc.Title^Alternative	
+730, 740		  -> dc.Title^Alternative	
 
-100, 110, 111		  -> Creator			
-700, 710, 711		  -> Creator			
-720			  -> Creator
+100, 110, 111		  -> dc.Creator			
+700, 710, 711		  -> dc.Creator			
+720			  -> dc.Creator
 
 # at later date might want to distinguish between
 # (LCSH encoding, 2nd indicator=0) and (MeSH encoding, 2nd indicator=2)
-600, 610, 611, 630, 650	  -> Subject		        # LCSH or MeSH encoding	
-050			  -> Subject		        # LCC encoding
-082			  -> Subject			# DDC encoding
-080			  -> Subject			# UDC encoding
+600, 610, 611, 630, 650	  -> dc.Subject		        # LCSH or MeSH encoding	
+050			  -> dc.Subject		        # LCC encoding
+082			  -> dc.Subject			# DDC encoding
+080			  -> dc.Subject			# UDC encoding
 
-500-504, 507-519, 521-529 -> Description
-531-539, 541-545, 547-599 -> Description
-505			  -> Description^TableofContents
-520			  -> Description^Abstract	# First indicator=3
+500-504, 507-519, 521-529 -> dc.Description
+531-539, 541-545, 547-599 -> dc.Description
+505			  -> dc.Description^TableofContents
+520			  -> dc.Description^Abstract	# First indicator=3
 
-260$a$b			  -> Publisher			
+260$a$b			  -> dc.Publisher			
 
-260$c$g			  -> Date^Created		
-533$d			  -> Date^Created
-260$c			  -> Date^Issued
+260$c$g			  -> dc.Date^Created		
+533$d			  -> dc.Date^Created
+260$c			  -> dc.Date^Issued
 # Control field substring, not currently supported by mapping
-# 008/07-10		  -> Date^Issued   
+# 008/07-10		  -> dc.Date^Issued   
 
 # Leader fields not currently supported by mapping
-# Leader06, Leader07	  -> Type			# DCMI Type Vocabulary
-655			  -> Type			# Subfield $2=dct
+# Leader06, Leader07	  -> dc.Type			# DCMI Type Vocabulary
+655			  -> dc.Type			# Subfield $2=dct
 
-856$q			  -> Format			# IMT encoding
-300$a			  -> Format^Extent
-533$e			  -> Format^Extent
-340$a			  -> Format^Medium
+856$q			  -> dc.Format			# IMT encoding
+300$a			  -> dc.Format^Extent
+533$e			  -> dc.Format^Extent
+340$a			  -> dc.Format^Medium
 
-856$u			  -> Identifier			# URI encoding
+856$u			  -> dc.Identifier		# URI encoding
 
-786$o			  -> Source			# URI encoding
+786$o			  -> dc.Source			# URI encoding
 
 # Control field substring, not currently supported
-# 008/35-37		  -> Language			# ISO 639-2 encoding 
-041			  -> Language			# ISO 639-2 encoding 
-546			  -> Language			# RFC1766 encoding
+# 008/35-37		  -> dc.Language		# ISO 639-2 encoding 
+041			  -> dc.Language		# ISO 639-2 encoding 
+546			  -> dc.Language		# RFC1766 encoding
 
-775			  -> Relation^IsVersionOf	
-786$n$t			  -> Relation^IsVersionOf	
-775,786$o		  -> Relation^IsVersionOf	# URI encoding
-775$n$t			  -> Relation^HasVersion	
-775$o			  -> Relation^HasVersion	# URL encoding
-785$n$t			  -> Relation^IsReplacedBy	
-785$o			  -> Relation^IsReplacedBy	# URL encoding
-780$n$t			  -> Relation^Replaces	
-780$o			  -> Relation^Replaces		# URL encoding
-538			  -> Relation^Requires	
-760	  		  -> Relation^IsPartOf	
-773$n$t			  -> Relation^IsPartOf	
-440,490,800,810,811,830	  -> Relation^IsPartOf
-760,773$o		  -> Relation^IsPartOf		# URL encoding
-774$n$t			  -> Relation^HasPart		
-774$o			  -> Relation^HasPart		# URL encoding
-510			  -> Relation^IsReferencedBy	
-776$n$t			  -> Relation^IsFormatOf	
-530			  -> Relation^IsFormatOf	
-776$o			  -> Relation^IsFormatOf	# URL encoding
-530$u			  -> Relation^IsFormatOf	# URL encoding
-776$n$t			  -> Relation^HasFormat	
-530			  -> Relation^HasFormat		
-776$o			  -> Relation^HasFormat		# URL encoding
-530$u			  -> Relation^HasFormat		# URL encoding
+775			  -> dc.Relation^IsVersionOf	
+786$n$t			  -> dc.Relation^IsVersionOf	
+775,786$o		  -> dc.Relation^IsVersionOf	# URI encoding
+775$n$t			  -> dc.Relation^HasVersion	
+775$o			  -> dc.Relation^HasVersion	# URL encoding
+785$n$t			  -> dc.Relation^IsReplacedBy	
+785$o			  -> dc.Relation^IsReplacedBy	# URL encoding
+780$n$t			  -> dc.Relation^Replaces	
+780$o			  -> dc.Relation^Replaces	# URL encoding
+538			  -> dc.Relation^Requires	
+760	  		  -> dc.Relation^IsPartOf	
+773$n$t			  -> dc.Relation^IsPartOf	
+440,490,800,810,811,830	  -> dc.Relation^IsPartOf
+760,773$o		  -> dc.Relation^IsPartOf	# URL encoding
+774$n$t			  -> dc.Relation^HasPart		
+774$o			  -> dc.Relation^HasPart	# URL encoding
+510			  -> dc.Relation^IsReferencedBy	
+776$n$t			  -> dc.Relation^IsFormatOf	
+530			  -> dc.Relation^IsFormatOf	
+776$o			  -> dc.Relation^IsFormatOf	# URL encoding
+530$u			  -> dc.Relation^IsFormatOf	# URL encoding
+776$n$t			  -> dc.Relation^HasFormat	
+530			  -> dc.Relation^HasFormat		
+776$o			  -> dc.Relation^HasFormat	# URL encoding
+530$u			  -> dc.Relation^HasFormat	# URL encoding
 
-522, 651		  -> Coverage^Spatial		
-255			  -> Coverage^Spatial		# Some 255 information equivalent to DC encoding scheme but different syntax
+522, 651		  -> dc.Coverage^Spatial		
+255			  -> dc.Coverage^Spatial	# Some 255 information equivalent to DC encoding scheme but different syntax
  			
-650$z			  -> Coverage^Spatial
-752			  -> Coverage^Spatial
+650$z			  -> dc.Coverage^Spatial
+752			  -> dc.Coverage^Spatial
 
-043$c,044$c		  -> Coverage^Spatial		# ISO 3166 encoding
-651			  -> Coverage^Spatial		# Subfield $2=tgn # Encoding TGN
-513$b			  -> Coverage^Temporal	
-033$a			  -> Coverage^Temporal	
+043$c,044$c		  -> dc.Coverage^Spatial	# ISO 3166 encoding
+651			  -> dc.Coverage^Spatial	# Subfield $2=tgn # Encoding TGN
+513$b			  -> dc.Coverage^Temporal	
+033$a			  -> dc.Coverage^Temporal	
 
-506, 540		  -> Rights			
+506, 540		  -> dc.Rights			
 